#define CLK_0 digitalWrite(12, 0)
#define CLK_1 digitalWrite(12, 1)
#define LCK_0 digitalWrite(10, 0)
#define LCK_1 digitalWrite(10, 1)
#define MOSI_0 digitalWrite(11, 0)
#define MOSI_1 digitalWrite(11, 1)

unsigned char number[8] = {1,2,3,4,5,6,7,8};

unsigned char number_display[11] = {
  0b00111111,
  0b00000110,
  0b01011011,
  0b01001111,
  0b01100110,
  0b01101101,
  0b01111101,
  0b00000111,
  0b01111111,
  0b01101111,
  0b00000000
};

void shift_in(unsigned char x1, unsigned char x2)
{
  int i = 0;
  CLK_1;
  LCK_0;
  for (i = 0; i < 8; i++)
  {
    if (x1 & 0x80)
      MOSI_1;
    else
      MOSI_0;
    x1 <<= 1;
    CLK_0;
    CLK_1;
  }

  for (i = 0; i < 8; i++)
  {
    if (x2 & 0x80)
      MOSI_1;
    else
      MOSI_0;
    x2 <<= 1;
    CLK_0;
    CLK_1;
  }
  
  LCK_1;
  LCK_0;
}

void setup() {
  // put your setup code here, to run once:
  pinMode(10, OUTPUT);  //LCK
  pinMode(11, OUTPUT);  //MOSI
  pinMode(12, OUTPUT);  //CLK
}

void loop() {
  // put your main code here, to run repeatedly:
  for (int i = 0; i < 8; i++)
  {
    shift_in(~(1<<i), number_display[i+2]);
  }
}
